#include <string>
#include <iostream>
#include <map>
#include <set>
#include <fstream>

using namespace std;

/**
 * Represents one team (code-submitting entity)
 **/
struct Team
{
    string name;
    string fullName;
    set< string > solved;       // Problems solved
    map< string, int > tries;   // Number of submission of a problem
    //team_t type;
    //...

    Team() {}
    Team( string n, string fn ) : name( n ), fullName( fn ) {}
};

/**
 * maps team names to Team objects
 **/
extern map< string, Team > g_teams;

/**
 * The set of problem names that are judgeable
 **/
extern set< string > g_probs;

/**
 * Reads the team file, the problem file, and the log, initializing stuff.
 **/
void initdb( string teamfile, string probfile, string logfile );

/**
 * Param testing functions
 **/
bool teamExists( string team );
bool probExists( string prob );
bool langExists( string lang );

/**
 * Language-specific compile and run command lines
 **/
const char *compileCmd( string lang );
const char *executeCmd( string lang );

/**
 * Language-specific source file suffices
 **/
const char *sourceSuffix( string lang );



